Index: tests/syntax
===================================================================
--- tests/syntax	(revision 344)
+++ tests/syntax	(working copy)
@@ -2026,51 +2996,38 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:304: \${COMPILE_ONLY} prog.cob"
-echo definition.at:304 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:7: Warning: Redefinition of 'X'
+{ set +x
+$as_echo "$at_srcdir/definition.at:301: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:301"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:7: Warning: Redefinition of 'X'
 prog.cob:6: Warning: 'X' previously defined here
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "definition.at:304: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/definition.at:301"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_19
+#AT_START_20
+at_fn_group_banner 20 'definition.at:308' \
+  "Redefinition of 88 items" "                       "
+at_xfail=no
+(
+  $as_echo "20. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  20 ) # 20. definition.at:308: Redefinition of 88 items
-    at_setup_line='definition.at:308'
-    at_desc='Redefinition of 88 items'
-    $at_quiet $ECHO_N " 20: Redefinition of 88 items                     $ECHO_C"
-    at_xfail=no
-    (
-      echo "20. definition.at:308: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2083,51 +3040,38 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:324: \${COMPILE_ONLY} prog.cob"
-echo definition.at:324 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:8: Warning: Redefinition of 'A'
+{ set +x
+$as_echo "$at_srcdir/definition.at:321: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:321"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:8: Warning: Redefinition of 'A'
 prog.cob:7: Warning: 'A' previously defined here
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "definition.at:324: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/definition.at:321"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_20
+#AT_START_21
+at_fn_group_banner 21 'definition.at:328' \
+  "Ambiguous reference to 02 items" "                "
+at_xfail=no
+(
+  $as_echo "21. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  21 ) # 21. definition.at:328: Ambiguous reference to 02 items
-    at_setup_line='definition.at:328'
-    at_desc='Ambiguous reference to 02 items'
-    $at_quiet $ECHO_N " 21: Ambiguous reference to 02 items              $ECHO_C"
-    at_xfail=no
-    (
-      echo "21. definition.at:328: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2145,52 +3089,39 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:350: \${COMPILE_ONLY} prog.cob"
-echo definition.at:350 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:11: Error: 'X' ambiguous; need qualification
+{ set +x
+$as_echo "$at_srcdir/definition.at:346: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:346"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:11: Error: 'X' ambiguous; need qualification
 prog.cob:7: Error: 'X' in 'G1' defined here
 prog.cob:9: Error: 'X' in 'G2' defined here
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "definition.at:350: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/definition.at:346"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_21
+#AT_START_22
+at_fn_group_banner 22 'definition.at:354' \
+  "Ambiguous reference to 02 and 03 items" "         "
+at_xfail=no
+(
+  $as_echo "22. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  22 ) # 22. definition.at:354: Ambiguous reference to 02 and 03 items
-    at_setup_line='definition.at:354'
-    at_desc='Ambiguous reference to 02 and 03 items'
-    $at_quiet $ECHO_N " 22: Ambiguous reference to 02 and 03 items       $ECHO_C"
-    at_xfail=no
-    (
-      echo "22. definition.at:354: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2207,52 +3138,39 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:375: \${COMPILE_ONLY} prog.cob"
-echo definition.at:375 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:10: Error: 'X' ambiguous; need qualification
+{ set +x
+$as_echo "$at_srcdir/definition.at:371: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:371"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:10: Error: 'X' ambiguous; need qualification
 prog.cob:7: Error: 'X' in 'G' defined here
 prog.cob:8: Error: 'X' in 'X' in 'G' defined here
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "definition.at:375: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/definition.at:371"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_22
+#AT_START_23
+at_fn_group_banner 23 'definition.at:379' \
+  "Ambiguous reference with qualification" "         "
+at_xfail=no
+(
+  $as_echo "23. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  23 ) # 23. definition.at:379: Ambiguous reference with qualification
-    at_setup_line='definition.at:379'
-    at_desc='Ambiguous reference with qualification'
-    $at_quiet $ECHO_N " 23: Ambiguous reference with qualification       $ECHO_C"
-    at_xfail=no
-    (
-      echo "23. definition.at:379: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2272,52 +3190,39 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:403: \${COMPILE_ONLY} prog.cob"
-echo definition.at:403 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:13: Error: 'Y' in 'X' ambiguous; need qualification
+{ set +x
+$as_echo "$at_srcdir/definition.at:399: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:399"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:13: Error: 'Y' in 'X' ambiguous; need qualification
 prog.cob:8: Error: 'Y' in 'X' in 'G1' defined here
 prog.cob:11: Error: 'Y' in 'X' in 'G2' defined here
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "definition.at:403: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/definition.at:399"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_23
+#AT_START_24
+at_fn_group_banner 24 'definition.at:409' \
+  "Unique reference with ambiguous qualifiers" "     "
+at_xfail=no
+(
+  $as_echo "24. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  24 ) # 24. definition.at:409: Unique reference with ambiguous qualifiers
-    at_setup_line='definition.at:409'
-    at_desc='Unique reference with ambiguous qualifiers'
-    $at_quiet $ECHO_N " 24: Unique reference with ambiguous qualifiers   $ECHO_C"
-    at_xfail=no
-    (
-      echo "24. definition.at:409: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2337,49 +3242,35 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:429: \${COMPILE_ONLY} prog.cob"
-echo definition.at:429 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "definition.at:429: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/definition.at:429: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:429"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/definition.at:429"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_24
+#AT_START_25
+at_fn_group_banner 25 'definition.at:445' \
+  "Undefined procedure name" "                       "
+at_xfail=no
+(
+  $as_echo "25. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  25 ) # 25. definition.at:445: Undefined procedure name
-    at_setup_line='definition.at:445'
-    at_desc='Undefined procedure name'
-    $at_quiet $ECHO_N " 25: Undefined procedure name                     $ECHO_C"
-    at_xfail=no
-    (
-      echo "25. definition.at:445: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2390,50 +3281,37 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:458: \${COMPILE_ONLY} prog.cob"
-echo definition.at:458 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:5: Error: 'END-OF-PROGRAM' undefined
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "definition.at:458: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/definition.at:456: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:456"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:5: Error: 'END-OF-PROGRAM' undefined
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/definition.at:456"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_25
+#AT_START_26
+at_fn_group_banner 26 'definition.at:465' \
+  "Redefinition of section names" "                  "
+at_xfail=no
+(
+  $as_echo "26. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  26 ) # 26. definition.at:465: Redefinition of section names
-    at_setup_line='definition.at:465'
-    at_desc='Redefinition of section names'
-    $at_quiet $ECHO_N " 26: Redefinition of section names                $ECHO_C"
-    at_xfail=no
-    (
-      echo "26. definition.at:465: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2445,52 +3323,39 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:481: \${COMPILE_ONLY} prog.cob"
-echo definition.at:481 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob: In section 'L':
+{ set +x
+$as_echo "$at_srcdir/definition.at:477: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:477"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob: In section 'L':
 prog.cob:6: Error: Redefinition of 'L'
 prog.cob:5: Error: 'L' previously defined here
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "definition.at:481: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/definition.at:477"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_26
+#AT_START_27
+at_fn_group_banner 27 'definition.at:485' \
+  "Redefinition of section and paragraph names" "    "
+at_xfail=no
+(
+  $as_echo "27. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  27 ) # 27. definition.at:485: Redefinition of section and paragraph names
-    at_setup_line='definition.at:485'
-    at_desc='Redefinition of section and paragraph names'
-    $at_quiet $ECHO_N " 27: Redefinition of section and paragraph names  $ECHO_C"
-    at_xfail=no
-    (
-      echo "27. definition.at:485: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2502,52 +3367,39 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:501: \${COMPILE_ONLY} prog.cob"
-echo definition.at:501 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob: In section 'L':
+{ set +x
+$as_echo "$at_srcdir/definition.at:497: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:497"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob: In section 'L':
 prog.cob:6: Error: Redefinition of 'L'
 prog.cob:5: Error: 'L' previously defined here
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "definition.at:501: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/definition.at:497"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_27
+#AT_START_28
+at_fn_group_banner 28 'definition.at:505' \
+  "Redefinition of paragraph names" "                "
+at_xfail=no
+(
+  $as_echo "28. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  28 ) # 28. definition.at:505: Redefinition of paragraph names
-    at_setup_line='definition.at:505'
-    at_desc='Redefinition of paragraph names'
-    $at_quiet $ECHO_N " 28: Redefinition of paragraph names              $ECHO_C"
-    at_xfail=no
-    (
-      echo "28. definition.at:505: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2559,32 +3411,20 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:518: \${COMPILE_ONLY} prog.cob"
-echo definition.at:518 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-$at_diff $at_devnull $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "definition.at:518: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/definition.at:517: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:517"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+at_fn_diff_devnull "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/definition.at:517"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
-
-
 ## Change when we DON'T allow this
 ## AT_CHECK([${COMPILE_ONLY} prog.cob], [1], ,
 ## [prog.cob: In paragraph 'L':
@@ -2592,23 +3432,21 @@
 ## prog.cob:5: Error: 'L' previously defined here
 ## ])
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_28
+#AT_START_29
+at_fn_group_banner 29 'definition.at:529' \
+  "Ambiguous reference to paragraph name" "          "
+at_xfail=no
+(
+  $as_echo "29. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
-  29 ) # 29. definition.at:529: Ambiguous reference to paragraph name
-    at_setup_line='definition.at:529'
-    at_desc='Ambiguous reference to paragraph name'
-    $at_quiet $ECHO_N " 29: Ambiguous reference to paragraph name        $ECHO_C"
-    at_xfail=no
-    (
-      echo "29. definition.at:529: testing ..."
-      $at_traceon
 
 
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2624,53 +3462,40 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:550: \${COMPILE_ONLY} prog.cob"
-echo definition.at:550 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob: In section 'S-3':
+{ set +x
+$as_echo "$at_srcdir/definition.at:545: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:545"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob: In section 'S-3':
 prog.cob:10: Error: 'L' ambiguous; need qualification
 prog.cob:6: Error: 'L' in 'S-1' defined here
 prog.cob:8: Error: 'L' in 'S-2' defined here
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "definition.at:550: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/definition.at:545"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_29
+#AT_START_30
+at_fn_group_banner 30 'definition.at:554' \
+  "Non-matching level numbers (extension)" "         "
+at_xfail=no
+(
+  $as_echo "30. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  30 ) # 30. definition.at:554: Non-matching level numbers (extension)
-    at_setup_line='definition.at:554'
-    at_desc='Non-matching level numbers (extension)'
-    $at_quiet $ECHO_N " 30: Non-matching level numbers (extension)       $ECHO_C"
-    at_xfail=no
-    (
-      echo "30. definition.at:554: testing ..."
-      $at_traceon
-
-
-
 cat >test.conf <<'_ATEOF'
 
 include "default.conf"
@@ -2694,50 +3519,37 @@
 _ATEOF
 
 
-$at_traceoff
-echo "definition.at:578: \${COMPILE_ONLY} -conf=test.conf prog.cob"
-echo definition.at:578 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} -conf=test.conf prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:9: Warning: No previous data item of level 04
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "definition.at:578: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/definition.at:576: \${COMPILE_ONLY} -conf=test.conf prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "definition.at:576"
+( $at_check_trace; ${COMPILE_ONLY} -conf=test.conf prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:9: Warning: No previous data item of level 04
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/definition.at:576"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_30
+#AT_START_31
+at_fn_group_banner 31 'expression.at:23' \
+  "Ambiguous AND/OR" "                               "
+at_xfail=no
+(
+  $as_echo "31. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  31 ) # 31. expression.at:23: Ambiguous AND/OR
-    at_setup_line='expression.at:23'
-    at_desc='Ambiguous AND/OR'
-    $at_quiet $ECHO_N " 31: Ambiguous AND/OR                             $ECHO_C"
-    at_xfail=no
-    (
-      echo "31. expression.at:23: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2755,51 +3567,38 @@
 _ATEOF
 
 
-$at_traceoff
-echo "expression.at:44: \${COMPILE_ONLY} prog.cob"
-echo expression.at:44 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:6: Warning: Suggest parentheses around AND within OR
+{ set +x
+$as_echo "$at_srcdir/expression.at:41: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "expression.at:41"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:6: Warning: Suggest parentheses around AND within OR
 prog.cob:10: Warning: Suggest parentheses around AND within OR
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   0) ;;
-   *) echo "expression.at:44: exit code was $at_status, expected 0"
-      at_failed=:;;
-esac
-if $at_failed; then
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 0 $at_status "$at_srcdir/expression.at:41"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_31
+#AT_START_32
+at_fn_group_banner 32 'expression.at:48' \
+  "START on SEQUENTIAL file" "                       "
+at_xfail=no
+(
+  $as_echo "32. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  32 ) # 32. expression.at:48: START on SEQUENTIAL file
-    at_setup_line='expression.at:48'
-    at_desc='START on SEQUENTIAL file'
-    $at_quiet $ECHO_N " 32: START on SEQUENTIAL file                     $ECHO_C"
-    at_xfail=no
-    (
-      echo "32. expression.at:48: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
@@ -2822,50 +3621,37 @@
 _ATEOF
 
 
-$at_traceoff
-echo "expression.at:73: \${COMPILE_ONLY} prog.cob"
-echo expression.at:73 >$at_check_line_file
-( $at_traceon; ${COMPILE_ONLY} prog.cob ) >$at_stdout 2>$at_stder1
-at_status=$?
-grep '^ *+' $at_stder1 >&2
-grep -v '^ *+' $at_stder1 >$at_stderr
-at_failed=false
-echo >>$at_stderr; echo "prog.cob:16: Error: START not allowed on SEQUENTIAL files
-" | $at_diff - $at_stderr || at_failed=:
-$at_diff $at_devnull $at_stdout || at_failed=:
-case $at_status in
-   77) echo 77 > $at_status_file
-            exit 77;;
-   1) ;;
-   *) echo "expression.at:73: exit code was $at_status, expected 1"
-      at_failed=:;;
-esac
-if $at_failed; then
+{ set +x
+$as_echo "$at_srcdir/expression.at:71: \${COMPILE_ONLY} prog.cob"
+at_fn_check_prepare_notrace 'a ${...} parameter expansion' "expression.at:71"
+( $at_check_trace; ${COMPILE_ONLY} prog.cob
+) >>"$at_stdout" 2>>"$at_stderr" 5>&-
+at_status=$? at_failed=false
+$at_check_filter
+echo >>"$at_stderr"; $as_echo "prog.cob:16: Error: START not allowed on SEQUENTIAL files
+" | \
+  $at_diff - "$at_stderr" || at_failed=:
+at_fn_diff_devnull "$at_stdout" || at_failed=:
+at_fn_check_status 1 $at_status "$at_srcdir/expression.at:71"
+$at_failed && at_fn_log_failure
+$at_traceon; }
 
-  echo 1 > $at_status_file
-  exit 1
-fi
 
-$at_traceon
+  set +x
+  $at_times_p && times >"$at_times_file"
+) 5>&1 2>&1 7>&- | eval $at_tee_pipe
+read at_status <"$at_status_file"
+#AT_STOP_32
+#AT_START_33
+at_fn_group_banner 33 'subscripts.at:33' \
+  "Subscripted item requires OCCURS clause" "        "
+at_xfail=no
+(
+  $as_echo "33. $at_setup_line: testing $at_desc ..."
+  $at_traceon
 
 
-      $at_traceoff
-      $at_times_p && times >$at_times_file
-    ) 5>&1 2>&1 | eval $at_tee_pipe
-    at_status=`cat $at_status_file`
-    ;;
 
-  33 ) # 33. subscripts.at:33: Subscripted item requires OCCURS clause
-    at_setup_line='subscripts.at:33'
-    at_desc='Subscripted item requires OCCURS clause'
-    $at_quiet $ECHO_N " 33: Subscripted item requires OCCURS clause      $ECHO_C"
-    at_xfail=no
-    (
-      echo "33. subscripts.at:33: testing ..."
-      $at_traceon
-
-
-
 cat >prog.cob <<'_ATEOF'
 
        IDENTIFICATION   DIVISION.
